
-- Parametres globaux
gPluginName="KikiInventory";
gDebug = {};
-- gDebug.gBag=true;
-- gDebug.gWallet=true;
-- gDebug.gVault=true;
-- gDebug.gShared=true;
gDebug.gPanel=true;

-- Import 
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

import "Kiki.Commons.Trace";
import "Kiki.Commons.UTF";
import "Kiki.Commons.Class";
import "Kiki.Commons.Tools";
import "Kiki.Commons.Settings";
import "Kiki.Commons.Tooltips";
import "Kiki.Commons.Onscreen";
import "Kiki.KikiInventory.Languages";

-- Charge les traductions
gLanguage = getClientLanguage();
gLang = getLang(gLanguage); 

-- Joueur
gPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
gPlayerName = gPlayer:GetName();


-- Fonction de contruction d'un set de rsultat de recherche
 function Filter_Search(storage,name,text) 	
	local res = {};
	-- Toutes les fonctions "filter" prenne comme parametre
	-- arg#1 une structure identique  celle retourne
	-- arg#2 un nom de personnage ou nil si aucun filtre de personnage
	-- arg#3 une chaine devant tre contenu dans l'element ou nil si pas de filtrage a appliquer
	-- Toutes les fonctions "filter" retourne un tableau dont chaque element est 
	-- { desc: description; owner: nom-du-perso; type: vault|bag|wallet; qty: #; iconId: #; backId: # }
	if storage==nil or storage=="bag" then
		res = gBag.Filter(res, name, text);
	end
	if storage==nil or storage=="vault" then
		res = gVault.Filter(res, name, text);
	end
	if storage==nil or storage=="shared" then
		res = gShared.Filter(res, name, text);
	end
	if storage==nil or storage=="wallet" then
		res = gWallet.Filter(res, name, text);
	end

	-- Tri du resultat
	table.sort(res, Filter_sortByName);
	
	return res;
end

-- Utilitaire de tri des resultats
function Filter_sortByName(i,j)
	if i.desc == j.desc then
		if i.owner == j.owner then
			return i.type < j.type;
		end
		return i.owner < j.owner;
	end
	return i.desc < j.desc;
end

-- fonction d'affichage de la recherche dans la fenetre de chat
function Filter_DisplayInChat(text)
	Turbine.Shell.WriteLine(gLang.CCSEARCHTOP.." [<rgb=#ff0000>"..text.."</rgb>] "..gLang.CCSEARCHTOP2);
	local res = Filter_Search(nil,nil,text);
	local n= 0;
	-- Affiche le rsultat
	local prev=nil;
	local liste="";
	for i,item in pairs(res) do
		if item.desc ~= prev then
			if #liste > 0 then
				Turbine.Shell.WriteLine(liste);
				liste = "";
			end 
			prev = item.desc;
			-- Nouvel lment trouv....
			Turbine.Shell.WriteLine("<rgb=#ff0000>".. item.desc .. "</rgb>");
		end
		if #liste > 0 then
			liste = liste .. ", ";
		else
			liste = ">>";
		end
		liste = liste .. item.perso .. "(";
		if item.loc ~= item.perso then
			liste = liste .. item.loc ..":"
		end 
		liste = liste .. item.qty .. ")" ;
		n = n + 1; 
	end
	if #liste > 0 then
		Turbine.Shell.WriteLine(liste);
		liste = "";
	end 
	if n == 0 then
		Turbine.Shell.WriteLine(gLang.NOTFOUND);
	end
	Turbine.Shell.WriteLine(gLang.CCSEARCHBOT2);
	 	
end



import "Kiki.KikiInventory.gWallet";
import "Kiki.KikiInventory.gBag";
import "Kiki.KikiInventory.gShared";
import "Kiki.KikiInventory.gVault";
import "Kiki.KikiInventory.gPanel";




-- Function de dechargment du plugin
Plugins[gPluginName].Unload = function(self,sender,args)
	gPanel:Unload();
	gBag.Unload();
	gWallet.Unload();
	gShared.Unload();
	gVault.Unload();
	Kiki.Commons.Trace("unloaded");
end




-------------------------------------------------
-- Chargement
-------------------------------------------------
gBag.Load();
gWallet.Load();
gShared.Load();
gVault.Load();


-- commande /inv
scCommand = Turbine.ShellCommand();
Turbine.Shell.AddCommand(gLang.COMMAND, scCommand);
function scCommand:GetShortHelp()
    return gLang.USAGE;
end
function scCommand:GetHelp()
    return self:GetShortHelp();
end
function scCommand:Execute(cmd, args)
	gWallet.Refresh();
	gBag.Refresh();
	if args ~= nil and #args > 0 then
		Filter_DisplayInChat(args);
	else
		gPanel:Show();
	end
end




-- Retrouve la version du plugin
Kiki.Commons.Trace("loaded (version ".. Plugins[gPluginName]:GetVersion() .. " by Kikiadoc@Sirannon)");
Kiki.Commons.Trace(gLang.USAGE);
Kiki.Commons.Trace(gLang.USAGE2);












