-- Gestion des SACS

gBag={};
gBag.bag = gPlayer:GetBackpack();
gBag.data = Kiki.Commons.Settings(gPluginName.."_bag", {} );
if gBag.data[gPlayerName] == nil then 
	gBag.data[gPlayerName]={};
end
if gBag.data[gPlayerName][gLanguage] == nil then 
	gBag.data[gPlayerName][gLanguage]={};
end

--
-- refresh the BagData[gplayName] table
--
gBag.Refresh = function()
	local size=gBag.bag:GetSize();
	local filled = 0;
	gBag.data[gPlayerName][gLanguage]={};
	for i=1,size do
		tmpItem=gBag.bag:GetItem(i);
		if tmpItem~=nil then
			filled=filled+1;
			local itemInfo=tmpItem:GetItemInfo();
			local name = itemInfo:GetName();
			local oldQty = 0;
			-- Si il y avait deja un element de cette nature dans l'inventaire, on cumule
			if gBag.data[gPlayerName][gLanguage][name] ~= nil then
				oldQty = gBag.data[gPlayerName][gLanguage][name].qty;
			end
			gBag.data[gPlayerName][gLanguage][name]= {name=name; qty=tmpItem:GetQuantity()+oldQty ; backId=itemInfo:GetBackgroundImageID() ; iconId=itemInfo:GetIconImageID()};
			-- Kiki.Commons.Trace(itemInfo:GetDescription());
		end
	end
	gBag.data[gPlayerName].Filled=filled;
	gBag.data[gPlayerName].Capacity=size;
end

--
-- dump le contenu du sac
--
gBag.Dump = function()
	for k,v in pairs(gBag.data[gPlayerName][gLanguage]) do
		Kiki.Commons.Trace(k.."="..v.name);
	end
end

--
-- filtrage
-- return une table de { desc: description; perso=nomPerso; owner: nom-du-perso; type: vault|bag|wallet|shared; qty: #; iconId: #; backId: # }
--
gBag.Filter=function(res, name,text)
	for usr,bag in pairs(gBag.data) do
		if name == nil or name==usr then 
			for i,d in pairs(bag[gLanguage]) do
				if (#d.name>0) and (text == nil or string.find(d.name, text ,1,true))  then
					local v = { desc= d.name; perso=usr; loc=gLang.BAG; owner=usr.."\n("..gLang.BAG..")"; type="bag"; qty=d.qty; iconId = d.iconId; backId=d.backId   }
					table.insert(res,v);
				end 
			end
		end
	end
	return res;
end

--
-- Suppression d'un personnage dans les sacs
--
gBag.Delete=function(name)
	gBag.data[name]=nil;
end

--
-- Unload
--
gBag.Unload = function()
	gBag.Refresh();
	gBag.data:Save(gPluginName.."_bag");
end

--
-- Chargement
--
gBag.Load = function()
	gBag.Refresh();
end
