-- Gestion du stockage partag

gShared={};
gShared.shared = gPlayer:GetSharedStorage();
gShared.data = Kiki.Commons.Settings(gPluginName.."_shared", {} );

-- Initialiser  NIL si besoin, si aucun element rcupr depuis la sauvegarde
if gShared.data[gLanguage]==nil then gShared.data[gLanguage]={}; end

-- Recharge le contenu du stockage
gShared.Refresh = function()

	if gShared.shared:IsAvailable() == false then
		if gDebug.gShared then
			Kiki.Commons.Trace("Too far away from shared storage");
		end
		return;
	end
	local size=gShared.shared:GetCount();
	if size == 0 then
		-- Mise  jour diffre
		if gDebug.gShared then
			Kiki.Commons.Trace("shared storage available but update delayed");
		end
		return;
	end
	
	if gDebug.gShared then
		Kiki.Commons.Trace("shared storage introspection in progress, size="..size);
	end
	local filled = 0;
	local selection = {};
	for i=1,size do
		tmpItem=gShared.shared:GetItem(i);
		if tmpItem~=nil then
			filled=filled+1;
			local itemInfo=tmpItem:GetItemInfo();
			local name=itemInfo:GetName();
			local oldQty = 0;
			if selection[name] ~= nil then
				oldQty = selection[name].qty;
			end
			selection[name]= {name=name ; qty=tmpItem:GetQuantity() + oldQty ; iconId=itemInfo:GetIconImageID();backId=itemInfo:GetBackgroundImageID()};
		end
	end
	gShared.data[gLanguage]=selection;
	gShared.data.Filled=filled;
	gShared.data.Capacity=size;
end

-- dump le contenu du stockage partag
gShared.Dump = function()
	for k,v in pairs(gShared.data[gLanguage]) do
		Kiki.Commons.Trace(k.."="..v.name.." ("..v.qty..")");
	end
end

-- filtrage
-- return une table de { desc: description; perso:nomduperso; owner: nom-du-perso; type: vault|bag|wallet|shared; qty: #; iconId: #; backId: # }
gShared.Filter=function(res, name,text)
	for i,d in pairs(gShared.data[gLanguage]) do
		if (d~= nil) and (#d.name>0) and (text == nil or string.find(d.name, text ,1,true))  then
				local v = { desc= d.name; perso=gLang.SHARED; loc=gLang.SHARED; owner=gLang.SHARED; type="shared"; qty=d.qty; iconId = d.iconId; backId=d.backId   }
				table.insert(res,v);
		end 
	end
	return res;
end


-- Callbacks
gShared.IsAvailableChanged = function(sender, args)
	gShared.Refresh();
end
gShared.ItemsRefreshed = function(sender, args)
	gShared.Refresh();
end
gShared.CountChanged = function(sender, args)
	gShared.Refresh();
end
gShared.CapacityChanged = function(sender, args)
	gShared.Refresh();
end

-- Initialisation des callbacks
gShared.AddCallBacks = function()
	AddCallback(gShared.shared,"IsAvailableChanged",gShared.IsAvailableChanged);
	AddCallback(gShared.shared,"ItemsRefreshed",gShared.ItemsRefreshed);
	-- AddCallback(gShared.shared,"ChestChanged",gShared.Refresh);
	-- AddCallback(gShared.shared,"ChestNameChanged",gShared.Refresh);
	AddCallback(gShared.shared,"CountChanged",gShared.CountChanged);
	AddCallback(gShared.shared,"CapacityChanged",gShared.CapacityChanged);
end

-- Suppression des callbakcs
gShared.RemoveCallBacks = function()
	RemoveCallback(gShared.shared,"IsAvailableChanged",gShared.IsAvailableChanged);
	RemoveCallback(gShared.shared,"ItemsRefreshed",gShared.ItemsRefreshed);
	RemoveCallback(gShared.shared,"CountChanged",gShared.CountChanged);
	RemoveCallback(gShared.shared,"CapacityChanged",gShared.CapacityChanged);
end


gShared.Unload = function()
	gShared.RemoveCallBacks();
	gShared.data:Save(gPluginName.."_shared");
end


-- Initialisation
gShared.Load=function()
	gShared.AddCallBacks();
	gShared.Refresh();
end


