-- Gestion du stockage partag

gVault={};
gVault.vault = gPlayer:GetVault();
gVault.data = Kiki.Commons.Settings(gPluginName.."_vault", {} );

if gVault.data[gPlayerName]== nil then gVault.data[gPlayerName]={}; end
if gVault.data[gPlayerName][gLanguage]==nil then gVault.data[gPlayerName][gLanguage]={}; end

-- Recharge le contenu du stockage
gVault.Refresh = function()

	if gVault.vault:IsAvailable() == false then
		if gDebug.gVault then
			Kiki.Commons.Trace("Too far away from Vault");
		end
		return;
	end
	local size=gVault.vault:GetCount();
	if size == 0 then
		-- Mise  jour diffre
		if gDebug.gVault then
			Kiki.Commons.Trace("Vault available but update delayed");
		end
		return;
	end
	
	if gDebug.gVault then
		Kiki.Commons.Trace("Vault introspection in progress, size="..size);
	end
	local filled = 0;
	local selection = {};
	for i=1,size do
		tmpItem=gVault.vault:GetItem(i);
		if tmpItem ~= nil then
			filled=filled+1;
			local itemInfo=tmpItem:GetItemInfo();
			local name = itemInfo:GetName();
			local oldQty = 0;
			-- Si il y avait deja un element de cette nature dans l'inventaire, on cumule
			if selection[name] ~= nil then
				oldQty = selection[name].qty;
			end
			selection[name]= {name=name;qty=tmpItem:GetQuantity() + oldQty;backId=itemInfo:GetBackgroundImageID(); iconId=itemInfo:GetIconImageID()};
			-- Kiki.Commons.Trace(dump(gVault.data[gLanguage][i]));
		end
	end
	gVault.data[gPlayerName][gLanguage]=selection;
	gVault.data[gPlayerName].Filled=filled;
	gVault.data[gPlayerName].Capacity=size;
end

-- dump le contenu du coffre
gVault.Dump = function()
	for usr,elt in pairs(gVault.data) do
		for i,desc in pairs(elt[gLanguage]) do
			Kiki.Commons.Trace(usr.."="..desc.name.." ("..desc.qty..")");
		end
	end
end

-- filtrage
-- return une table de { desc: description; perso:nomperso; owner: nom-du-perso; type: vault|bag|wallet|shared; qty: #; iconId: #; backId: # }
gVault.Filter=function(res, name,text)
	for usr,elt in pairs(gVault.data) do
		if name == nil or name==usr then 
			for i,d in pairs(elt[gLanguage]) do
				if (#d.name>0) and (text == nil or string.find(d.name, text ,1,true))  then
					local v = { desc= d.name; perso=usr; loc=gLang.VAULT; owner=usr.."\n("..gLang.VAULT..")"; type="vault"; qty=d.qty; iconId = d.iconId; backId=d.backId   }
					table.insert(res,v);
				end 
			end
		end
	end
	return res;
end


-- Suppression d'un personnage dans les coffres
gVault.Delete=function(name)
	gVault.data[name]=nil;
end


-- Callbacks
gVault.IsAvailableChanged = function(sender, args)
	gVault.Refresh();
end
gVault.ItemsRefreshed = function(sender, args)
	gVault.Refresh();
end
gVault.CountChanged = function(sender, args)
	gVault.Refresh();
end
gVault.CapacityChanged = function(sender, args)
	gVault.Refresh();
end

-- Initialisation des callbacks
gVault.AddCallBacks = function()
	AddCallback(gVault.vault,"IsAvailableChanged",gVault.IsAvailableChanged);
	AddCallback(gVault.vault,"ItemsRefreshed",gVault.ItemsRefreshed);
	-- AddCallback(gVault.vault,"ChestChanged",gVault.Refresh);
	-- AddCallback(gVault.vault,"ChestNameChanged",gVault.Refresh);
	AddCallback(gVault.vault,"CountChanged",gVault.CountChanged);
	AddCallback(gVault.vault,"CapacityChanged",gVault.CapacityChanged);
end

-- Suppression des callbakcs
gVault.RemoveCallBacks = function()
	RemoveCallback(gVault.vault,"IsAvailableChanged",gVault.IsAvailableChanged);
	RemoveCallback(gVault.vault,"ItemsRefreshed",gVault.ItemsRefreshed);
	RemoveCallback(gVault.vault,"CountChanged",gVault.CountChanged);
	RemoveCallback(gVault.vault,"CapacityChanged",gVault.CapacityChanged);
end


gVault.Unload = function()
	gVault.RemoveCallBacks();
	gVault.data:Save(gPluginName.."_vault");
end


-- Initialisation
gVault.Load=function()
	gVault.AddCallBacks();
	gVault.Refresh();
end


